// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { cors } from '../../../lib/cors';

export default async function handler(req, res) 
{
	await cors(req, res);

	return new Promise(async (resolve) => 
	{
		if(req.headers.cookie !== undefined)
		{
			const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");

			console.log("req.body");
			console.log(req.body);

			if(cookies.jwt !== undefined && cookies.jwt !== null)
			{
				console.log("cookies.jwt");
				console.log(cookies.jwt);

				var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
				var crm_jwt = jwt.sign(client_jwt_decoded, process.env.JWT_SECRET_CRM, { noTimestamp: true });

				console.log("client_jwt_decoded", client_jwt_decoded);
				console.log("crm_jwt", crm_jwt);

				console.log(`${ process.env.CRM_API_HOST }/lk/Contract/GetOsago`);

				const result = {
					osago: null, 
					kasko: null, 
					nsib: null, 
				};

				await Promise.all([ 
					new Promise((resolve_osago) => {
						axios.get(`${ process.env.CRM_API_HOST }/lk/Contract/GetOsago`, {
							params: { ...client_jwt_decoded, contract_number: req.body.number }, 
							headers: { "Authorization": `Bearer ${ crm_jwt }`, }, 
						})
						.then((crm_response) => { 
							result.osago = crm_response.data; 
							resolve_osago(); 
						})
						.catch((error) => { 
							console.error(error); 
							resolve_osago(); 
						});
					}), 
					new Promise((resolve_kasko) => {
						axios.get(`${ process.env.CRM_API_HOST }/lk/Contract/GetKasko`, {
							params: { ...client_jwt_decoded, contract_number: req.body.number }, 
							headers: { "Authorization": `Bearer ${ crm_jwt }`, }, 
						})
						.then((crm_response) => { 
							result.kasko = crm_response.data; 
							resolve_kasko(); 
						})
						.catch((error) => { 
							console.error(error); 
							resolve_kasko(); 
						});
					}), 
					new Promise((resolve_nsib) => {
						axios.get(`${ process.env.CRM_API_HOST }/lk/Contract/GetNsib`, {
							params: { ...client_jwt_decoded, contract_number: req.body.number }, 
							headers: { "Authorization": `Bearer ${ crm_jwt }`, }, 
						})
						.then((crm_response) => { 
							result.nsib = crm_response.data; 
							resolve_nsib(); 
						})
						.catch((error) => { 
							console.error(error); 
							resolve_nsib(); 
						});
					}), 
					new Promise((resolve_fingap) => {
						axios.get(`${ process.env.CRM_API_HOST }/lk/Contract/GetFinGap`, {
							params: { ...client_jwt_decoded, contract_number: req.body.number }, 
							headers: { "Authorization": `Bearer ${ crm_jwt }`, }, 
						})
						.then((crm_response) => { 
							result.fingap = crm_response.data;
							resolve_fingap(); 
						})
						.catch((error) => { 
							console.error(error); 
							resolve_fingap(); 
						});
					}), 
				])
				.then(() => 
				{
					res.status(200).json(result);
					resolve();
				});
			}
			else
			{
				res.status(403).send();
				resolve();
			}
		}
		else
		{
			res.status(403).send();
			resolve();
		}
	});
}